use std::{fs::File, io::{Read, Write}};
use env_logger::Builder;
use log::{error, info, LevelFilter};
use rand::Rng;
use xobjects::{XArgument, XSomeList};

mod objects;
mod xobjects;
mod deserializer;
mod serializer;

/*
[lib]
crate-type = ["staticlib", "cdylib", "lib"]
*/

fn main() {

    // Initialize the logger with 'info' as the default level
    Builder::new()
        .filter(None, LevelFilter::Info)
        .init();

    // /Users/michael/Documents/ipod/iTunes/iTunesDB
    let mut f = File::open("D:\\Documents\\iTunes\\iTunesDB").unwrap(); // D:\\Documents\\iTunes\\iTunesDB
    let mut buf = Vec::new();
    match f.read_to_end(&mut buf) {
        Ok(n) => {
            let data = &buf[..n];
            let mut xdb = deserializer::parse_bytes(data);
            //info!("XDB: {:#?}", xdb);


            let json = serde_json::to_string_pretty(&xdb).unwrap();
            let mut f1 = File::create("output.json").unwrap();
            f1.write(json.as_bytes());

           /* let unique_id = rand::thread_rng().gen_range(10..99);

            if let XSomeList::TrackList(tracks) = &mut xdb.find_dataset(1).child {
                /*let mut item = (*tracks.last().unwrap()).clone();
                let mut xargs = Vec::new();
                xargs.push(XArgument { arg_type: 1, val: String::from("They beat you") });
                xargs.push(XArgument { arg_type: 6, val: String::from("MPEG audio file")});
                xargs.push(XArgument { arg_type: 2, val: String::from(":iPod_Control:Music:F38:ZXXX.mp3") });
                item.args = xargs;
                item.data.number_of_strings = 3;
                item.data.unique_id = unique_id;
                item.data.dbid = rand::thread_rng().gen_range(0..10000);
                item.data.dbid2 = rand::thread_rng().gen_range(0..10000);
                tracks.push(item);*/
                let mut item = tracks.last_mut().unwrap();
                item.args.first_mut().unwrap().val = String::from("Goy next door");
            } */ 
            
            /*if let XSomeList::Playlists(playlists) = &mut xdb.find_dataset(3).child {
                let playlist = playlists.last_mut().unwrap();
                let elem = playlist.elems.last().unwrap();
                let mut pl_item = elem.0.clone();
                pl_item.track_id = unique_id;
                playlist.elems.push((pl_item, elem.1.clone()));
            }*/

            let mut op = File::create("outdb").unwrap();
            info!("Write res: {:?}", op.write(&serializer::to_bytes(xdb)));
        },
        Err(e) => {
            error!("Error: {}",e);
        }
    }
}
